INSERT INTO RIGHTS (NUSER, PRAVICA)
SELECT R2.NUSER, 'CRANE_PLANNING_EDIT' FROM RIGHTS R2
WHERE R2.PRAVICA = 'CRANE_PLANNING_MOBILE_EDIT'
AND NOT EXISTS (SELECT * FROM RIGHTS R3 WHERE R3.NUSER = R2.NUSER AND R3.PRAVICA = 'CRANE_PLANNING_EDIT');

DELETE FROM RIGHTS
WHERE PRAVICA = 'CRANE_PLANNING_MOBILE_EDIT';

INSERT INTO DEPARTMENT_RIGHTS (ID, NDEPARTMENT, PRAVICA)
SELECT DEPARTMENT_RIGHTS_SEQ.NEXTVAL, R2.NDEPARTMENT, 'CRANE_PLANNING_EDIT' FROM DEPARTMENT_RIGHTS R2
WHERE R2.PRAVICA = 'CRANE_PLANNING_MOBILE_EDIT'
AND NOT EXISTS (SELECT * FROM DEPARTMENT_RIGHTS R3 WHERE R3.NDEPARTMENT = R2.NDEPARTMENT AND R3.PRAVICA = 'CRANE_PLANNING_EDIT');

DELETE FROM DEPARTMENT_RIGHTS
WHERE PRAVICA = 'CRANE_PLANNING_MOBILE_EDIT';

DELETE FROM NRIGHTS
where pravica = 'CRANE_PLANNING_MOBILE_EDIT';

ALTER TABLE M_DE_NA
ADD TYPE VARCHAR2(2 CHAR);

UPDATE M_DE_NA
SET TYPE = 'OF'
WHERE STATUS IN ('P', 'Z') AND TYPE IS NULL;

UPDATE M_DE_NA
SET TYPE = 'WO'
WHERE STATUS NOT IN ('P', 'Z') AND TYPE IS NULL;

CREATE OR REPLACE VIEW V_M_DE_NA AS (
SELECT M.ID_DN, M.ID_LASTNIKA, M.ID_PLOVILA, M.ID_RACUNA, M.ID_PREDRACUN, M.ID_REZERVACIJE, M.ID_POGODBE, M.STEVILKA, M.STATUS, M.ORG_STATUS, M.USER_KREIRANJA, M.USER_SPREMEMBE, M.CONFIRMED, 
M.DATUM_DN, M.TERMIN_DO, M.SKUPAJ, M.SKUPAJ_VAL, M.KOMENTAR, M.LASTNIK_OBVESCEN, M.NNLOCATION_ID, M.ID_OWNER_SIGNATURE, M.TYPE,
OFR.STEVILKA AS OFFER_STEVILKA, N.OPIS AS NNSTATDN_OPIS, NS.DESCRIPTION AS NNSTATPON_DESCRIPTION, 
K.PRIIMEK AS KUPCI_PRIIMEK, K.IME AS KUPCI_IME, CONCAT(CONCAT(NVL(K.PRIIMEK, ''), ' '), NVL(K.IME, '')) AS KUPCI_PRIIMEK_IME, K.VALUTA_PLACILA AS KUPCI_VALUTA_PLACILA, 
P.IME AS PLOVILA_IME, L.OPIS AS NNLOCATION_OPIS, L.INTERNI_OPIS AS NNLOCATION_INTERNI_OPIS, 
(SELECT AVG(NVL(COMPLETE, 0)) FROM M_STORITVE MS WHERE MS.ID_DN = M.ID_DN) AS SERVICE_COMPLETE_AVERAGE,
(SELECT SUM(NVL(S.ZA_PLACILO, 0)) FROM SALDKONT S WHERE S.ID_DN = M.ID_DN AND S.SDK_RN_TIP = 'I' AND S.SDK_RN_PL = 'P') AS SUM_ISSUED_PAYMENTS,
(SELECT COUNT(ID) FROM NAJAVE WHERE VRSTA_NAJAVE = 'CRANE' AND ID_DN = M.ID_DN)  AS CRANE_PLAN_COUNT
FROM M_DE_NA M
LEFT OUTER JOIN M_DE_NA OFR ON OFR.ID_DN = M.ID_PREDRACUN
LEFT OUTER JOIN NNSTATDN N ON N.SIFRA = M.STATUS
LEFT OUTER JOIN NNSTATPON NS ON NS.CODE = M.CONFIRMED
LEFT OUTER JOIN KUPCI K ON K.ID = M.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA P ON P.ID = M.ID_PLOVILA
LEFT OUTER JOIN NNLOCATION L ON L.ID = M.NNLOCATION_ID
);

CREATE OR REPLACE
TRIGGER M_DE_NA_TYPE_TRG
BEFORE INSERT OR UPDATE
ON M_DE_NA
REFERENCING NEW AS NEW OLD AS OLD
FOR EACH ROW
BEGIN
  :NEW.TYPE := (CASE WHEN :NEW.STATUS IN ('P', 'Z') THEN 'OF' ELSE 'WO' END);;
END;;
;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1370, SYSDATE, '5.5', 1290, 'MDeNa type')
;