ALTER TABLE TIPSERVIS
ADD ACTIVE VARCHAR2(1 CHAR) DEFAULT 'Y';

CREATE TABLE ASSET_TYPE_WO_TEMPLATE (
ID_ASSET_TYPE_WO_TEMPLATE NUMBER NOT NULL,
ID_ASSET_TYPE NUMBER,
ID_WORK_ORDER_TEMPLATE NUMBER,
CONSTRAINT ASSET_TYPE_WO_TEMPLATE_PK PRIMARY KEY (ID_ASSET_TYPE_WO_TEMPLATE),
CONSTRAINT ASSET_TYPE_WO_TMP_ASS_TYPE_FK FOREIGN KEY (ID_ASSET_TYPE) REFERENCES ASSET_TYPE(ID_ASSET_TYPE),
CONSTRAINT ASSET_TYPE_WO_TMP_WO_TMP_FK FOREIGN KEY (ID_WORK_ORDER_TEMPLATE) REFERENCES WORK_ORDER_TEMPLATE(ID)
);

CREATE SEQUENCE ASSET_TYPE_WO_TEMPLATE_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

ALTER TABLE ASSET
ADD ID_ASSET_PARENT NUMBER;

CREATE INDEX IX_ASSET_ID_ASSET_PARENT ON ASSET (ID_ASSET_PARENT);

DROP VIEW V_MAINTENANCE_TASK;

CREATE OR REPLACE VIEW V_MAINTENANCE_TASK AS (
SELECT M.ID_MAINTENANCE_TASK, M.ID_TYPE, M.ID_STATUS, M.ID_ASSET, M.ID_DN, M.ID_CHECKLIST, M.ID_QUESTION_ANSWER_CHECKLIST, M.NNLOCATION_ID, M.DATE_FROM, M.DATE_TO, M."COMMENT", M.ID_STORITVE,
MT.DESCRIPTION AS TYPE_DESCRIPTION, MT.TYPE AS MAIN_TYPE_CODE, MS.DESCRIPTION AS STATUS_DESCRIPTION, MS.COLOR AS STATUS_COLOR, MS.TEXT_COLOR AS STATUS_TEXT_COLOR, 
A.NAME AS ASSET_NAME, A.MANAGER AS ASSET_MANAGER, A.LIFT_CODE AS ASSET_LIFT_CODE, C.NAME AS CHECKLIST_NAME, C.MANAGER AS CHECKLIST_MANAGER
FROM MAINTENANCE_TASK M
LEFT OUTER JOIN MAINTENANCE_TYPE MT ON MT.ID_MAINTENANCE_TYPE = M.ID_TYPE
LEFT OUTER JOIN MAINTENANCE_STATUS MS ON MS.ID_MAINTENANCE_STATUS = M.ID_STATUS
LEFT OUTER JOIN ASSET A ON A.ID_ASSET = M.ID_ASSET
LEFT OUTER JOIN CHECKLIST C ON C.ID_CHECKLIST = M.ID_CHECKLIST
);

DROP VIEW V_ASSET;

CREATE OR REPLACE VIEW V_ASSET AS (
  SELECT A.ID_ASSET, A.ID_ASSET_PARENT, A.ID_TYPE, A.ID_CATEGORY, A.NAME, A.DESCRIPTION, A.SERIAL_NUMBER, A.REGISTRATION_NUMBER, A.MANAGER, A.NNLOCATION_ID, A.ACTIVE,
  AP.NAME AS PARENT_ASSET_NAME, AT.DESCRIPTION AS TYPE_DESCRIPTION, AC.DESCRIPTION AS CATEGORY_DESCRIPTION, NU.USER_ AS NUSER_USER,
  (SELECT MAX(M.DATE_TO) FROM MAINTENANCE_TASK M WHERE M.ID_ASSET = A.ID_ASSET AND M.ID_STATUS = 3) AS LAST_MAINTENANCE_DATE
  FROM ASSET A
  LEFT OUTER JOIN ASSET AP ON AP.ID_ASSET = A.ID_ASSET_PARENT
  LEFT OUTER JOIN ASSET_TYPE AT ON AT.ID_ASSET_TYPE = A.ID_TYPE
  LEFT OUTER JOIN ASSET_CATEGORY AC ON AC.ID_ASSET_CATEGORY = A.ID_CATEGORY
  LEFT OUTER JOIN NUSER NU ON NU.NUSER = A.MANAGER
);

DROP VIEW V_CHECKLIST;

CREATE OR REPLACE VIEW V_CHECKLIST AS (
  SELECT C.ID_CHECKLIST, C.ID_TYPE, C.NAME, C.DESCRIPTION, C.MANAGER, C.NNLOCATION_ID, C.ACTIVE,
  CT.DESCRIPTION AS TYPE_DESCRIPTION, NU.USER_ AS NUSER_USER,
  (SELECT MAX(M.DATE_TO) FROM MAINTENANCE_TASK M WHERE M.ID_CHECKLIST = C.ID_CHECKLIST AND M.ID_STATUS = 3) AS LAST_MAINTENANCE_DATE
  FROM CHECKLIST C
  LEFT OUTER JOIN CHECKLIST_TYPE CT ON CT.ID_CHECKLIST_TYPE = C.ID_TYPE
  LEFT OUTER JOIN NUSER NU ON NU.NUSER = C.MANAGER
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1501, SYSDATE, '5.5', 1421, 'Maintenance')
;