DROP VIEW V_RESERVATION;

CREATE OR REPLACE VIEW V_RESERVATION AS (
  SELECT RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, RE.STATUS_REZERVAC, RE.KOMENTAR, RE.DATUM_REZERVACIJE, RE.DATUM_DO, RE.PRIVEZ, RE.ID_PRIVEZ, RE.ODPOVED, RE.HOURLY, RE.CHECKIN_STATUS, RE.CHECKIN_TIME, RE.CHECKOUT_TIME,
  NNPR.NNLOCATION_ID, DE.ID_REZERVAC_DETAIL AS REZERVAC_DETAIL_ID, DE.DATUM_OD AS REZERVAC_DETAIL_DATUM_OD, DE.DATUM_DO AS REZERVAC_DETAIL_DATUM_DO, DE.STATUS_REZERVAC AS REZERVAC_DETAIL_STATUS, DE.COMPLETE AS REZERVAC_DETAIL_COMPLETE,
  DE.TIME_FROM AS REZERVAC_DETAIL_TIME_FROM, DE.TIME_TO AS REZERVAC_DETAIL_TIME_TO,
  NND.N_PRIVEZA AS REZERVAC_DETAIL_PRIVEZ, NND.ID_PRIVEZ AS REZERVAC_DETAIL_ID_PRIVEZ, NND.OCCUPANCY_STATISTICS AS REZERVAC_DETAIL_OCC_STAT, NNPD.NNLOCATION_ID AS REZERVAC_DETAIL_NNLOCATION_ID, 
  KU.IME AS KUPCI_IME, KU.PRIIMEK AS KUPCI_PRIIMEK,
  (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
  THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND DE.DATUM_DO IS NOT NULL AND DE.TIME_TO IS NOT NULL AND TRUNC(DE.TIME_TO) <> DE.TIME_TO THEN DE.DATUM_DO - 1 ELSE DE.DATUM_DO END)) 
  ELSE DE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO,
  (CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE (CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (KU.IME || ' ' || KU.PRIIMEK) ELSE (KU.PRIIMEK || ' ' || KU.IME) END) END) AS OWNER,
  (CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
  (CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
  (CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
  (CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
  (CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
  (CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA,
  (CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DATUM_ZAVAROVANJE ELSE PL.DATUM_ZAVAROVANJE END) AS DATUM_ZAVAROVANJE,
  (CASE WHEN RE.STATUS_REZERVAC IN (0, 1, 2) THEN 'Y' ELSE 'N' END) AS RECEIVED,
  (CASE WHEN RE.STATUS_REZERVAC = 0 THEN 'Y' ELSE 'N' END) AS DEPARTED
  FROM REZERVAC RE
  JOIN REZERVAC_DETAIL DE ON RE.ID = DE.ID_REZERVAC
  LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
  LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
  LEFT OUTER JOIN NNPRIVEZ NND ON NND.ID_PRIVEZ = DE.ID_PRIVEZ
  LEFT OUTER JOIN NNPOMOL NNPD ON NNPD.SIFRA = NND.KATEGORIJA
  LEFT OUTER JOIN NNPRIVEZ NNR ON NNR.ID_PRIVEZ = RE.ID_PRIVEZ
  LEFT OUTER JOIN NNPOMOL NNPR ON NNPR.SIFRA = NNR.KATEGORIJA
);

DROP VIEW V_REZERVAC;

CREATE OR REPLACE VIEW V_REZERVAC AS (
SELECT R.ID AS ID_REZERVAC, D.ID_REZERVAC_DETAIL, R.ID_POGODBE, D.DATUM_OD AS RD_DATE_FROM, D.DATUM_DO AS RD_DATE_TO, D.TIME_FROM AS RD_TIME_FROM, D.TIME_TO AS RD_TIME_TO,
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT NN.OBJEKT FROM NNPRIVEZ NN, NNOBJEKT NO WHERE NN.OBJEKT = NO.SIFRA AND NO.OBJECT_TYPE = 'EXIT') ELSE RDNP.OBJEKT END) AS RD_OBJEKT, 
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT NN.N_PRIVEZA FROM NNPRIVEZ NN, NNOBJEKT NO WHERE NN.OBJEKT = NO.SIFRA AND NO.OBJECT_TYPE = 'EXIT') ELSE RDNP.N_PRIVEZA END) AS RD_N_PRIVEZA,
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT NN.ID_PRIVEZ FROM NNPRIVEZ NN, NNOBJEKT NO WHERE NN.OBJEKT = NO.SIFRA AND NO.OBJECT_TYPE = 'EXIT') ELSE RDNP.ID_PRIVEZ END) AS RD_ID_PRIVEZ,
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT NN.NAME_PLACING FROM NNPRIVEZ NN, NNOBJEKT NO WHERE NN.OBJEKT = NO.SIFRA AND NO.OBJECT_TYPE = 'EXIT') ELSE RDNP.NAME_PLACING END) AS RD_NAME_PLACING,
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT NN.BOAT_GROUP_PLACING FROM NNPRIVEZ NN, NNOBJEKT NO WHERE NN.OBJEKT = NO.SIFRA AND NO.OBJECT_TYPE = 'EXIT') ELSE RDNP.BOAT_GROUP_PLACING END) AS RD_BOAT_GROUP_PLACING,
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT NN.BOAT_PLACING FROM NNPRIVEZ NN, NNOBJEKT NO WHERE NN.OBJEKT = NO.SIFRA AND NO.OBJECT_TYPE = 'EXIT') ELSE RDNP.BOAT_PLACING END) AS RD_BOAT_PLACING,
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT NN.OCCUPANCY_STATISTICS FROM NNPRIVEZ NN, NNOBJEKT NO WHERE NN.OBJEKT = NO.SIFRA AND NO.OBJECT_TYPE = 'EXIT') ELSE RDNP.OCCUPANCY_STATISTICS END) AS RD_OCCUPANCY_STATISTICS,
R.VRSTA, D.STATUS_REZERVAC AS RD_STATUS_REZERVAC, D.COMPLETE AS RD_COMPLETE, D.VRSTA AS RD_VRSTA, R.ID_LASTNIKA, R.ID_PLOVILA, R.OWNER_NOTIFIED, R.CHECKIN_STATUS, R.HOURLY,
R.DATUM_KREIRANJA AS R_DATUM_KREIRANJA, R.USER_KREIRANJA AS R_USER_KREIRANJA, R.DATUM_SPREMEMBE AS R_DATUM_SPREMEMBE, R.USER_SPREMEMBE AS R_USER_SPREMEMBE,
(CASE WHEN D.STATUS_REZERVAC = 2 THEN 'EXIT' ELSE NNO.OBJECT_TYPE END) AS OBJECT_TYPE,
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT OBLIKA FROM NNOBJEKT WHERE OBJECT_TYPE = 'EXIT') ELSE NNO.OBLIKA END) AS NNOBJEKT_OBLIKA,
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT CENTER_POZICIJA_PLOVILA FROM NNOBJEKT WHERE OBJECT_TYPE = 'EXIT') ELSE NNO.CENTER_POZICIJA_PLOVILA END) AS CENTER_POZICIJA_PLOVILA,
POGNP.OBJEKT AS POGODBA_OBJEKT, POGNP.N_PRIVEZA AS POGODBA_N_PRIVEZA, R.DATUM_REZERVACIJE AS R_DATE_FROM, R.DATUM_DO AS R_DATE_TO, R.TIME_FROM AS R_TIME_FROM, R.TIME_TO AS R_TIME_TO,
RNP.OBJEKT AS R_OBJEKT, RNP.N_PRIVEZA AS R_N_PRIVEZA, RNP.ID_PRIVEZ AS R_ID_PRIVEZ, R.STATUS_REZERVAC AS R_STATUS_REZERVAC,
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT NS.DOLZINA FROM NNPRIVEZ_SVG NS, NNPRIVEZ NN, NNOBJEKT NO WHERE NS.ID_PRIVEZ = NN.ID_PRIVEZ AND NN.OBJEKT = NO.SIFRA AND NO.OBJECT_TYPE = 'EXIT') ELSE NS.DOLZINA END) AS DOLZINA_PRIVEZA, 
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT NS.SIRINA FROM NNPRIVEZ_SVG NS, NNPRIVEZ NN, NNOBJEKT NO WHERE NS.ID_PRIVEZ = NN.ID_PRIVEZ AND NN.OBJEKT = NO.SIFRA AND NO.OBJECT_TYPE = 'EXIT') ELSE NS.SIRINA END) AS SIRINA_PRIVEZA, 
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT NS.TRANS_X FROM NNPRIVEZ_SVG NS, NNPRIVEZ NN, NNOBJEKT NO WHERE NS.ID_PRIVEZ = NN.ID_PRIVEZ AND NN.OBJEKT = NO.SIFRA AND NO.OBJECT_TYPE = 'EXIT') ELSE NS.TRANS_X END) AS TRANS_X_PRIVEZA, 
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT NS.TRANS_Y FROM NNPRIVEZ_SVG NS, NNPRIVEZ NN, NNOBJEKT NO WHERE NS.ID_PRIVEZ = NN.ID_PRIVEZ AND NN.OBJEKT = NO.SIFRA AND NO.OBJECT_TYPE = 'EXIT') ELSE NS.TRANS_Y END) AS TRANS_Y_PRIVEZA, 
(CASE WHEN D.STATUS_REZERVAC = 2 THEN (SELECT NS.ROT_DEGREES FROM NNPRIVEZ_SVG NS, NNPRIVEZ NN, NNOBJEKT NO WHERE NS.ID_PRIVEZ = NN.ID_PRIVEZ AND NN.OBJEKT = NO.SIFRA AND NO.OBJECT_TYPE = 'EXIT') ELSE NS.ROT_DEGREES END) AS ROT_DEGREES_PRIVEZA, 
(CASE WHEN R.STATUS_REZERVAC = 2 THEN NULL ELSE RD.TRANS_X END) AS TRANS_X_PLOVILA, (CASE WHEN R.STATUS_REZERVAC = 2 THEN NULL ELSE RD.TRANS_Y END) AS TRANS_Y_PLOVILA, (CASE WHEN R.STATUS_REZERVAC = 2 THEN NULL ELSE RD.ROT_DEGREES END) AS ROT_DEGREES_PLOVILA, 
R.KOMENTAR, K.ID_MEMBER AS KUPCI_ID_MEMBER, K.INT_CODE AS KUPCI_INT_CODE, RNNLOC.ID AS R_ID_LOCATION, RDNNLOC.ID AS RD_ID_LOCATION,
(SELECT COUNT(*) FROM M_DE_NA WHERE ID_PLOVILA = R.ID_PLOVILA AND (NNLOCATION_ID IS NULL OR NNLOCATION_ID = RDNNLOC.ID) AND UPPER(STATUS) = 'O') AS BOAT_OPEN_WO_NUMBER, 
(SELECT COUNT(*) FROM M_STORITVE WHERE ID_PLOVILA = R.ID_PLOVILA AND (NNLOCATION_ID IS NULL OR NNLOCATION_ID = RDNNLOC.ID) AND UPPER(VRSTA) IN ('PO', 'ST') AND N_RACUNA IS NULL) AS BOAT_OPEN_SERVICES_NUMBER,
RPD.ID_REZERVAC_PERIOD AS ID_REZERVAC_PERIOD, RVR.ACTIVE_LAST_DAY,
(CASE WHEN (SELECT COUNT(ID_CONTRACT_BERTH) FROM CONTRACT_BERTH CB WHERE CB.ID_POGODBE = R.ID_POGODBE AND CB.ID_PRIVEZ = D.ID_PRIVEZ) > 0 THEN 'Y' ELSE 'N' END) AS RD_CONTRACT_BERTH,
(CASE WHEN (SELECT COUNT(ID_CONTRACT_BERTH) FROM CONTRACT_BERTH CB LEFT OUTER JOIN V_PRIVEZ_LOCATION PRIV_LOCATION ON CB.ID_PRIVEZ = PRIV_LOCATION.ID_PRIVEZ WHERE CB.ID_POGODBE = R.ID_POGODBE AND NVL(PRIV_LOCATION.NNLOCATION_ID, 0) = NVL(RDNNLOC.ID, 0) ) > 0 THEN 'Y' ELSE 'N' END) AS RD_CONTRACT_BERTH_SAME_LOC,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN R.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND D.DATUM_DO IS NOT NULL AND D.TIME_TO IS NOT NULL AND TRUNC(D.TIME_TO) <> D.TIME_TO THEN D.DATUM_DO - 1 ELSE D.DATUM_DO END)) 
ELSE D.DATUM_DO END) AS RD_CALC_DATE_TO,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.NAZIV ELSE K.PRIIMEK END) AS NAZIV,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.PRIIMEK ELSE K.PRIIMEK END) AS PRIIMEK,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.IME ELSE K.IME END) AS IME, K.SALDAKONTI_SIT,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.EMAIL ELSE K.EMAIL END) AS EMAIL,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.TELEFON ELSE K.TELEFON_1 END) AS TELEFON,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN NULL ELSE K.TELEX END) AS TELEX,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.PLOVILO ELSE P.IME END) AS PLOVILO,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.DOLZINA ELSE P.DOLZINA END) AS DOLZINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.SIRINA ELSE P.SIRINA END) AS SIRINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.VISINA ELSE P.VISINA END) AS VISINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.GREZ ELSE P.GREZ END) AS GREZ,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.NTIP ELSE P.NTIP END) AS NTIP,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.OPIS ELSE NT.OPIS END) AS TIP_PLOVILA_LONG,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.NNTIP_TYPE ELSE NT.NNTIP_TYPE END) AS NNTIP_TYPE,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.DOLZINA ELSE NT.DOLZINA END) AS NNTIP_DOLZINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.SIRINA ELSE NT.SIRINA END) AS NNTIP_SIRINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.VISINA ELSE NT.VISINA END) AS NNTIP_VISINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE P.REGISTRSKA_N END) AS REGISTRSKA_N,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE P.NZASTAVA END) AS NZASTAVA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE ND.OPIS END) AS NZASTAVA_LONG,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.BARVA ELSE NT.BARVA END) AS BARVA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.SVG_OBLIKA_TOP ELSE NT.SVG_OBLIKA_TOP END) AS SVG_OBLIKA_TOP,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.SVG_OBLIKA_FRONT ELSE NT.SVG_OBLIKA_FRONT END) AS SVG_OBLIKA_FRONT,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE P.PROIZVAJALEC END) AS PROIZVAJALEC,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE P.BOOKING END) AS BOOKING
FROM REZERVAC R
JOIN REZERVAC_DETAIL D ON R.ID=D.ID_REZERVAC
LEFT OUTER JOIN NNPRIVEZ RDNP ON D.ID_PRIVEZ=RDNP.ID_PRIVEZ
LEFT OUTER JOIN NNPRIVEZ RNP ON R.ID_PRIVEZ=RNP.ID_PRIVEZ
LEFT OUTER JOIN KUPCI K ON K.ID = R.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA P ON P.ID = R.ID_PLOVILA
LEFT OUTER JOIN NNTIP NT ON NT.SIFRA = P.NTIP
LEFT OUTER JOIN NNTIP NTR ON NTR.SIFRA = R.NTIP
LEFT OUTER JOIN NNDRZAVE ND ON ND.SIFRA = P.NZASTAVA
LEFT OUTER JOIN NNOBJEKT NNO ON NNO.SIFRA = RDNP.OBJEKT
LEFT OUTER JOIN M_POGODBE MP ON MP.ID_POGODBE = R.ID_POGODBE
LEFT OUTER JOIN NNPRIVEZ POGNP ON MP.ID_PRIVEZ=POGNP.ID_PRIVEZ
LEFT OUTER JOIN NNPRIVEZ_SVG NS ON NS.ID_PRIVEZ = D.ID_PRIVEZ
LEFT OUTER JOIN REZERVAC_DETAIL_SVG RD ON RD.ID_REZERVAC = R.ID
LEFT OUTER JOIN NNPOMOL RNPOM ON RNPOM.SIFRA = RNP.KATEGORIJA
LEFT OUTER JOIN NNLOCATION RNNLOC ON RNNLOC.ID = RNPOM.NNLOCATION_ID
LEFT OUTER JOIN NNPOMOL RDNPOM ON RDNPOM.SIFRA = RDNP.KATEGORIJA
LEFT OUTER JOIN NNLOCATION RDNNLOC ON RDNNLOC.ID = RDNPOM.NNLOCATION_ID
LEFT OUTER JOIN REZERVAC_PERIOD_DETAIL RPD ON RPD.ID_REZERVAC = R.ID
LEFT OUTER JOIN NVRSTA_REZERVAC RVR ON RVR.CODE = R.VRSTA
WHERE R.STATUS_REZERVAC >= 0 AND R.DATUM_DO IS NOT NULL
UNION ALL
SELECT R.ID AS ID_REZERVAC, -D.ID_REZERVAC_DETAIL, R.ID_POGODBE, D.DATUM_DO AS RD_DATE_FROM, TRUNC(SYSDATE) + 1 AS RD_DATE_TO, D.TIME_FROM AS RD_TIME_FROM, D.TIME_TO AS RD_TIME_TO,
RDNP.OBJEKT AS RD_OBJEKT, RDNP.N_PRIVEZA AS RD_N_PRIVEZA, RDNP.ID_PRIVEZ AS RD_ID_PRIVEZ, RDNP.NAME_PLACING AS RD_NAME_PLACING, RDNP.BOAT_GROUP_PLACING AS RD_BOAT_GROUP_PLACING, RDNP.BOAT_PLACING AS RD_BOAT_PLACING, RDNP.OCCUPANCY_STATISTICS AS RD_OCCUPANCY_STATISTICS,
R.VRSTA, -10 AS RD_STATUS_REZERVAC, D.COMPLETE AS RD_COMPLETE, D.VRSTA AS RD_VRSTA, R.ID_LASTNIKA, R.ID_PLOVILA, R.OWNER_NOTIFIED, R.CHECKIN_STATUS, R.HOURLY,
R.DATUM_KREIRANJA AS R_DATUM_KREIRANJA, R.USER_KREIRANJA AS R_USER_KREIRANJA, R.DATUM_SPREMEMBE AS R_DATUM_SPREMEMBE, R.USER_SPREMEMBE AS R_USER_SPREMEMBE,
NNO.OBJECT_TYPE, NNO.OBLIKA AS NNOBJEKT_OBLIKA, NNO.CENTER_POZICIJA_PLOVILA AS CENTER_POZICIJA_PLOVILA, POGNP.OBJEKT AS POGODBA_OBJEKT, POGNP.N_PRIVEZA AS POGODBA_N_PRIVEZA, 
R.DATUM_REZERVACIJE AS R_DATE_FROM, R.DATUM_DO AS R_DATE_TO, R.TIME_FROM AS R_TIME_FROM, R.TIME_TO AS R_TIME_TO,
RNP.OBJEKT AS R_OBJEKT, RNP.N_PRIVEZA AS R_N_PRIVEZA, RNP.ID_PRIVEZ AS R_ID_PRIVEZ, R.STATUS_REZERVAC AS R_STATUS_REZERVAC,
NS.DOLZINA AS DOLZINA_PRIVEZA, NS.SIRINA AS SIRINA_PRIVEZA, NS.TRANS_X AS TRANS_X_PRIVEZA, NS.TRANS_Y AS TRANS_Y_PRIVEZA, NS.ROT_DEGREES AS ROT_DEGREES_PRIVEZA,
(CASE WHEN R.STATUS_REZERVAC = 2 THEN NULL ELSE RD.TRANS_X END) AS TRANS_X_PLOVILA, (CASE WHEN R.STATUS_REZERVAC = 2 THEN NULL ELSE RD.TRANS_Y END) AS TRANS_Y_PLOVILA, (CASE WHEN R.STATUS_REZERVAC = 2 THEN NULL ELSE RD.ROT_DEGREES END) AS ROT_DEGREES_PLOVILA, 
R.KOMENTAR, K.ID_MEMBER AS KUPCI_ID_MEMBER, K.INT_CODE AS KUPCI_INT_CODE, RNNLOC.ID AS R_ID_LOCATION, RDNNLOC.ID AS RD_ID_LOCATION,
(SELECT COUNT(*) FROM M_DE_NA WHERE ID_PLOVILA = R.ID_PLOVILA AND (NNLOCATION_ID IS NULL OR NNLOCATION_ID = RDNNLOC.ID) AND UPPER(STATUS) = 'O') AS BOAT_OPEN_WO_NUMBER, 
(SELECT COUNT(*) FROM M_STORITVE WHERE ID_PLOVILA = R.ID_PLOVILA AND (NNLOCATION_ID IS NULL OR NNLOCATION_ID = RDNNLOC.ID) AND UPPER(VRSTA) IN ('PO', 'ST') AND N_RACUNA IS NULL) AS BOAT_OPEN_SERVICES_NUMBER,
RPD.ID_REZERVAC_PERIOD AS ID_REZERVAC_PERIOD, NULL,
(CASE WHEN (SELECT COUNT(ID_CONTRACT_BERTH) FROM CONTRACT_BERTH CB WHERE CB.ID_POGODBE = R.ID_POGODBE AND CB.ID_PRIVEZ = D.ID_PRIVEZ) > 0 THEN 'Y' ELSE 'N' END) AS RD_CONTRACT_BERTH,
(CASE WHEN (SELECT COUNT(ID_CONTRACT_BERTH) FROM CONTRACT_BERTH CB LEFT OUTER JOIN V_PRIVEZ_LOCATION PRIV_LOCATION ON CB.ID_PRIVEZ = PRIV_LOCATION.ID_PRIVEZ WHERE CB.ID_POGODBE = R.ID_POGODBE AND NVL(PRIV_LOCATION.NNLOCATION_ID, 0) = NVL(RDNNLOC.ID, 0) ) > 0 THEN 'Y' ELSE 'N' END) AS RD_CONTRACT_BERTH_SAME_LOC,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN R.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND D.DATUM_DO IS NOT NULL AND D.TIME_TO IS NOT NULL AND TRUNC(D.TIME_TO) <> D.TIME_TO THEN D.DATUM_DO - 1 ELSE D.DATUM_DO END)) 
ELSE D.DATUM_DO END) AS RD_CALC_DATE_TO,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.NAZIV ELSE K.PRIIMEK END) AS NAZIV,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.PRIIMEK ELSE K.PRIIMEK END) AS PRIIMEK,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.IME ELSE K.IME END) AS IME, K.SALDAKONTI_SIT,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.EMAIL ELSE K.EMAIL END) AS EMAIL,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN R.TELEFON ELSE K.TELEFON_1 END) AS TELEFON,
(CASE WHEN R.ID_LASTNIKA IS NULL OR R.ID_LASTNIKA = 0 THEN NULL ELSE K.TELEX END) AS TELEX,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.PLOVILO ELSE P.IME END) AS PLOVILO,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.DOLZINA ELSE P.DOLZINA END) AS DOLZINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.SIRINA ELSE P.SIRINA END) AS SIRINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.VISINA ELSE P.VISINA END) AS VISINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.GREZ ELSE P.GREZ END) AS GREZ,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN R.NTIP ELSE P.NTIP END) AS NTIP,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.OPIS ELSE NT.OPIS END) AS TIP_PLOVILA_LONG,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.NNTIP_TYPE ELSE NT.NNTIP_TYPE END) AS NNTIP_TYPE,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.DOLZINA ELSE NT.DOLZINA END) AS NNTIP_DOLZINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.SIRINA ELSE NT.SIRINA END) AS NNTIP_SIRINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.VISINA ELSE NT.VISINA END) AS NNTIP_VISINA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE P.REGISTRSKA_N END) AS REGISTRSKA_N,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE P.NZASTAVA END) AS NZASTAVA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE ND.OPIS END) AS NZASTAVA_LONG,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.BARVA ELSE NT.BARVA END) AS BARVA,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.SVG_OBLIKA_TOP ELSE NT.SVG_OBLIKA_TOP END) AS SVG_OBLIKA_TOP,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NTR.SVG_OBLIKA_FRONT ELSE NT.SVG_OBLIKA_FRONT END) AS SVG_OBLIKA_FRONT,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE P.PROIZVAJALEC END) AS PROIZVAJALEC,
(CASE WHEN R.ID_PLOVILA IS NULL OR R.ID_PLOVILA = 0 THEN NULL ELSE P.BOOKING END) AS BOOKING
FROM REZERVAC R
JOIN REZERVAC_DETAIL D ON R.ID=D.ID_REZERVAC
LEFT OUTER JOIN NNPRIVEZ RDNP ON D.ID_PRIVEZ=RDNP.ID_PRIVEZ
LEFT OUTER JOIN NNPRIVEZ RNP ON R.ID_PRIVEZ=RNP.ID_PRIVEZ
LEFT OUTER JOIN KUPCI K ON K.ID = R.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA P ON P.ID = R.ID_PLOVILA
LEFT OUTER JOIN NNTIP NT ON NT.SIFRA = P.NTIP
LEFT OUTER JOIN NNTIP NTR ON NTR.SIFRA = R.NTIP
LEFT OUTER JOIN NNDRZAVE ND ON ND.SIFRA = P.NZASTAVA
LEFT OUTER JOIN NNOBJEKT NNO ON NNO.SIFRA = RDNP.OBJEKT
LEFT OUTER JOIN M_POGODBE MP ON MP.ID_POGODBE = R.ID_POGODBE
LEFT OUTER JOIN NNPRIVEZ POGNP ON MP.ID_PRIVEZ=POGNP.ID_PRIVEZ
LEFT OUTER JOIN NNPRIVEZ_SVG NS ON NS.ID_PRIVEZ = D.ID_PRIVEZ
LEFT OUTER JOIN REZERVAC_DETAIL_SVG RD ON RD.ID_REZERVAC = R.ID
LEFT OUTER JOIN NNPOMOL RNPOM ON RNPOM.SIFRA = RNP.KATEGORIJA
LEFT OUTER JOIN NNLOCATION RNNLOC ON RNNLOC.ID = RNPOM.NNLOCATION_ID
LEFT OUTER JOIN NNPOMOL RDNPOM ON RDNPOM.SIFRA = RDNP.KATEGORIJA
LEFT OUTER JOIN NNLOCATION RDNNLOC ON RDNNLOC.ID = RDNPOM.NNLOCATION_ID
LEFT OUTER JOIN REZERVAC_PERIOD_DETAIL RPD ON RPD.ID_REZERVAC = R.ID
WHERE R.DATUM_DO IS NOT NULL AND R.STATUS_REZERVAC = 1 AND D.DATUM_DO <= TRUNC(SYSDATE) AND D.ID_REZERVAC_DETAIL IN 
(SELECT ID_REZERVAC_DETAIL FROM REZERVAC_DETAIL WHERE DATUM_DO = (SELECT MAX(D2.DATUM_DO) FROM REZERVAC_DETAIL D2 WHERE D2.STATUS_REZERVAC = 1 AND D2.COMPLETE = 'Y' AND D2.ID_REZERVAC = R.ID))
);

DROP VIEW V_RESERVATIONS_MANAGEMENT;

CREATE OR REPLACE VIEW V_RESERVATIONS_MANAGEMENT AS 
(
SELECT 'ALARM_ARRIVAL' AS CATEGORY, CONCAT('ALARM_ARRIVAL', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, RE.STATUS_REZERVAC, RE.KOMENTAR,
RE.DATUM_REZERVACIJE AS DATE_FROM, RE.DATUM_DO AS DATE_TO, RE.TIME_FROM, RE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND RE.DATUM_DO IS NOT NULL AND RE.TIME_TO IS NOT NULL AND TRUNC(RE.TIME_TO) <> RE.TIME_TO THEN RE.DATUM_DO - 1 ELSE RE.DATUM_DO END)) 
ELSE RE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(RE.DATUM_REZERVACIJE) < TRUNC(SYSDATE) AND RE.STATUS_REZERVAC > 2 AND NOT EXISTS
(SELECT * FROM REZERVAC RE2 WHERE RE2.DATUM_REZERVACIJE < RE.DATUM_REZERVACIJE AND RE2.ID_PLOVILA = RE.ID_PLOVILA AND RE2.ID_PLOVILA > 0 AND RE2.STATUS_REZERVAC IN (1,2) )
UNION ALL
SELECT 'ALARM_DEPARTURE' AS CATEGORY, CONCAT('ALARM_DEPARTURE', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, RE.STATUS_REZERVAC, RE.KOMENTAR,
RE.DATUM_REZERVACIJE AS DATE_FROM, RE.DATUM_DO AS DATE_TO, RE.TIME_FROM, RE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND RE.DATUM_DO IS NOT NULL AND RE.TIME_TO IS NOT NULL AND TRUNC(RE.TIME_TO) <> RE.TIME_TO THEN RE.DATUM_DO - 1 ELSE RE.DATUM_DO END)) 
ELSE RE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN (CASE WHEN RE.DATUM_DO IS NOT NULL AND RE.TIME_TO IS NOT NULL AND TRUNC(RE.TIME_TO) <> RE.TIME_TO THEN RE.DATUM_DO - 1 ELSE RE.DATUM_DO END)
ELSE RE.DATUM_DO END) <= TRUNC(SYSDATE) 
AND RE.STATUS_REZERVAC IN (1,2) AND NOT EXISTS
(SELECT * FROM REZERVAC RE2 WHERE RE2.DATUM_REZERVACIJE = RE.DATUM_DO AND RE2.ID_PLOVILA = RE.ID_PLOVILA AND RE2.ID_PLOVILA > 0 AND RE2.STATUS_REZERVAC > 0)
UNION ALL
SELECT 'ALARM_MOVE' AS CATEGORY, CONCAT('ALARM_MOVE', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, DE.TIME_FROM, DE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND DE.DATUM_DO IS NOT NULL AND DE.TIME_TO IS NOT NULL AND TRUNC(DE.TIME_TO) <> DE.TIME_TO THEN DE.DATUM_DO - 1 ELSE DE.DATUM_DO END)) 
ELSE DE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 1 AND DE.STATUS_REZERVAC = 1 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND DE.DATUM_OD <= TRUNC(SYSDATE) AND EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 1 AND DE2.COMPLETE='Y')
UNION ALL
SELECT 'ALARM_EXIT' AS CATEGORY, CONCAT('ALARM_EXIT', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, DE.TIME_FROM, DE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND DE.DATUM_DO IS NOT NULL AND DE.TIME_TO IS NOT NULL AND TRUNC(DE.TIME_TO) <> DE.TIME_TO THEN DE.DATUM_DO - 1 ELSE DE.DATUM_DO END)) 
ELSE DE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 1 AND DE.STATUS_REZERVAC = 2 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND DE.DATUM_OD < TRUNC(SYSDATE) AND EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 1 AND DE2.COMPLETE='Y')
UNION ALL
SELECT 'ALARM_RETURN' AS CATEGORY, CONCAT('ALARM_RETURN', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, DE.TIME_FROM, DE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND DE.DATUM_DO IS NOT NULL AND DE.TIME_TO IS NOT NULL AND TRUNC(DE.TIME_TO) <> DE.TIME_TO THEN DE.DATUM_DO - 1 ELSE DE.DATUM_DO END)) 
ELSE DE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 2 AND DE.STATUS_REZERVAC = 1 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND DE.DATUM_OD < TRUNC(SYSDATE) AND EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 2 AND DE2.COMPLETE='Y')
UNION ALL
SELECT 'PLAN_ARRIVAL' AS CATEGORY, CONCAT('PLAN_ARRIVAL', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, RE.STATUS_REZERVAC, RE.KOMENTAR,
RE.DATUM_REZERVACIJE AS DATE_FROM, RE.DATUM_DO AS DATE_TO, RE.TIME_FROM, RE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND RE.DATUM_DO IS NOT NULL AND RE.TIME_TO IS NOT NULL AND TRUNC(RE.TIME_TO) <> RE.TIME_TO THEN RE.DATUM_DO - 1 ELSE RE.DATUM_DO END)) 
ELSE RE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(RE.DATUM_REZERVACIJE) >= TRUNC(SYSDATE) AND RE.STATUS_REZERVAC > 2
UNION ALL
SELECT 'PLAN_DEPARTURE' AS CATEGORY, CONCAT('PLAN_DEPARTURE', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, RE.STATUS_REZERVAC, RE.KOMENTAR,
RE.DATUM_REZERVACIJE AS DATE_FROM, RE.DATUM_DO AS DATE_TO, RE.TIME_FROM, RE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND RE.DATUM_DO IS NOT NULL AND RE.TIME_TO IS NOT NULL AND TRUNC(RE.TIME_TO) <> RE.TIME_TO THEN RE.DATUM_DO - 1 ELSE RE.DATUM_DO END)) 
ELSE RE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN (CASE WHEN RE.DATUM_DO IS NOT NULL AND RE.TIME_TO IS NOT NULL AND TRUNC(RE.TIME_TO) <> RE.TIME_TO THEN RE.DATUM_DO - 1 ELSE RE.DATUM_DO END)
ELSE RE.DATUM_DO END) >= TRUNC(SYSDATE) 
AND (RE.STATUS_REZERVAC IN (1, 2) OR (RE.STATUS_REZERVAC IN (3, 4) AND RE.VRSTA = 'RE')) AND NOT EXISTS
(SELECT * FROM REZERVAC RE2 WHERE RE2.DATUM_REZERVACIJE = RE.DATUM_DO AND RE2.ID_PLOVILA = RE.ID_PLOVILA AND RE2.ID_PLOVILA > 0 AND RE2.STATUS_REZERVAC > 0)
AND RE.DATUM_DO = (SELECT MAX(DE2.DATUM_DO) FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = DE.ID_REZERVAC AND DE2.ID_PRIVEZ = DE.ID_PRIVEZ AND DE2.STATUS_REZERVAC = DE.STATUS_REZERVAC)
UNION ALL
SELECT 'PLAN_MOVE' AS CATEGORY, CONCAT('PLAN_MOVE', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, DE.TIME_FROM, DE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND DE.DATUM_DO IS NOT NULL AND DE.TIME_TO IS NOT NULL AND TRUNC(DE.TIME_TO) <> DE.TIME_TO THEN DE.DATUM_DO - 1 ELSE DE.DATUM_DO END)) 
ELSE DE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(DE.DATUM_OD) >= TRUNC(SYSDATE) AND DE.STATUS_REZERVAC = 1 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND NOT EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 2)
UNION ALL
SELECT 'PLAN_EXIT' AS CATEGORY, CONCAT('PLAN_EXIT', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, DE.TIME_FROM, DE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND DE.DATUM_DO IS NOT NULL AND DE.TIME_TO IS NOT NULL AND TRUNC(DE.TIME_TO) <> DE.TIME_TO THEN DE.DATUM_DO - 1 ELSE DE.DATUM_DO END)) 
ELSE DE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(DE.DATUM_OD) >= TRUNC(SYSDATE) AND DE.STATUS_REZERVAC = 2 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N')
UNION ALL
SELECT 'PLAN_RETURN' AS CATEGORY, CONCAT('PLAN_RETURN', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, DE.TIME_FROM, DE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND DE.DATUM_DO IS NOT NULL AND DE.TIME_TO IS NOT NULL AND TRUNC(DE.TIME_TO) <> DE.TIME_TO THEN DE.DATUM_DO - 1 ELSE DE.DATUM_DO END)) 
ELSE DE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE TRUNC(DE.DATUM_OD) >= TRUNC(SYSDATE) AND DE.STATUS_REZERVAC = 1 AND (DE.COMPLETE IS NULL OR DE.COMPLETE = 'N') AND EXISTS
(SELECT * FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.DATUM_DO = DE.DATUM_OD AND DE2.STATUS_REZERVAC = 2)
UNION ALL
SELECT 'CURRENT_PRESENT' AS CATEGORY, CONCAT('CURRENT_PRESENT', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, DE.TIME_FROM, DE.TIME_TO, NN.N_PRIVEZA, NN.ID_PRIVEZ, VP.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND DE.DATUM_DO IS NOT NULL AND DE.TIME_TO IS NOT NULL AND TRUNC(DE.TIME_TO) <> DE.TIME_TO THEN DE.DATUM_DO - 1 ELSE DE.DATUM_DO END)) 
ELSE DE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN NNPRIVEZ NN ON NN.ID_PRIVEZ = DE.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VP ON VP.ID_PRIVEZ = NN.ID_PRIVEZ
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
WHERE RE.STATUS_REZERVAC = 1 AND DE.DATUM_OD = (SELECT MAX(DE2.DATUM_OD) FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.STATUS_REZERVAC = 1 AND DE2.COMPLETE = 'Y')
UNION ALL
SELECT 'CURRENT_EXIT' AS CATEGORY, CONCAT('CURRENT_EXIT', DE.ID_REZERVAC_DETAIL) AS V_RESERVATIONS_MANAGEMENT_ID, RE.ID AS ID_REZERVAC, RE.ID_LASTNIKA, RE.ID_PLOVILA, RE.VRSTA, RE.ID_POGODBE, DE.STATUS_REZERVAC, RE.KOMENTAR,
DE.DATUM_OD AS DATE_FROM, DE.DATUM_DO AS DATE_TO, DE.TIME_FROM, DE.TIME_TO,
VD.N_PRIVEZA, VD.ID_PRIVEZ, VD.NNLOCATION_ID, KU.SALDAKONTI_SIT, KU.ID_MEMBER, RE.PRIVEZ AS R_PRIVEZ, RE.ID_PRIVEZ AS R_ID_PRIVEZ, VPR.NNLOCATION_ID AS R_NNLOCATION_ID,
(CASE WHEN RE.ID_LASTNIKA IS NULL OR RE.ID_LASTNIKA = 0 THEN RE.NAZIV ELSE KU.PRIIMEK END) AS NAZIV,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.PLOVILO ELSE PL.IME END) AS PLOVILO,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.DOLZINA ELSE PL.DOLZINA END) AS DOLZINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.SIRINA ELSE PL.SIRINA END) AS SIRINA,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN RE.NTIP ELSE PL.NTIP END) AS NTIP,
(CASE WHEN RE.ID_PLOVILA IS NULL OR RE.ID_PLOVILA = 0 THEN NULL ELSE PL.NZASTAVA END) AS NZASTAVA, RE.LAST_PORT, RE.NEXT_PORT,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE NAZIV = 'CalculateReservationDateTo') = '1' 
THEN ((CASE WHEN RE.STATUS_REZERVAC IN ( 0, -1, 1, 2, -10) AND DE.DATUM_DO IS NOT NULL AND DE.TIME_TO IS NOT NULL AND TRUNC(DE.TIME_TO) <> DE.TIME_TO THEN DE.DATUM_DO - 1 ELSE DE.DATUM_DO END)) 
ELSE DE.DATUM_DO END) AS REZERVAC_DETAIL_CALC_DATE_TO
FROM REZERVAC RE
JOIN REZERVAC_DETAIL DE ON RE.ID=DE.ID_REZERVAC
LEFT OUTER JOIN KUPCI KU ON KU.ID = RE.ID_LASTNIKA
LEFT OUTER JOIN PLOVILA PL ON PL.ID = RE.ID_PLOVILA
LEFT OUTER JOIN V_PRIVEZ_LOCATION VPR ON VPR.ID_PRIVEZ = RE.ID_PRIVEZ
LEFT OUTER JOIN (SELECT ID, N_PRIVEZA, ID_PRIVEZ, NNLOCATION_ID, ID_LASTNIKA, ID_PLOVILA, KATEGORIJA_DOGODKA, ROW_NUMBER() OVER (PARTITION BY ID_LASTNIKA, ID_PLOVILA, KATEGORIJA_DOGODKA ORDER BY ID DESC) RNK FROM V_DOGODKI) VD
ON (VD.ID_LASTNIKA = RE.ID_LASTNIKA AND VD.ID_PLOVILA = RE.ID_PLOVILA AND VD.RNK = 1 AND VD.KATEGORIJA_DOGODKA = 'IZ')
WHERE RE.STATUS_REZERVAC = 2 AND DE.DATUM_OD = (SELECT MAX(DE2.DATUM_OD) FROM REZERVAC_DETAIL DE2 WHERE DE2.ID_REZERVAC = RE.ID AND DE2.STATUS_REZERVAC = 2 AND DE2.COMPLETE = 'Y')
)
;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1683, SYSDATE, '5.5', 1603, 'Rezervac date calc')
;