CREATE TABLE DUPLICATE_CHECK (
  ID_DUPLICATE_CHECK NUMBER NOT NULL,
  ID_TYPE NUMBER,
  DESCRIPTION VARCHAR2(200 CHAR),
  ACTIVE VARCHAR2(1 CHAR),
  CONSTRAINT DUPLICATE_CHECK_PK PRIMARY KEY (ID_DUPLICATE_CHECK)
);

CREATE INDEX IX_DUPLICATE_CHECK_ID_TYPE ON DUPLICATE_CHECK (ID_TYPE);

CREATE SEQUENCE DUPLICATE_CHECK_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

CREATE TABLE DUPLICATE_CHECK_FIELD (
  ID_DUPLICATE_CHECK_FIELD NUMBER NOT NULL,
  ID_DUPLICATE_CHECK NUMBER,
  FIELD_NAME VARCHAR2(100 CHAR),
  CONSTRAINT DUPLICATE_CHECK_FIELD_PK PRIMARY KEY (ID_DUPLICATE_CHECK_FIELD),
  CONSTRAINT DCF_ID_DUPLICATE_CHECK_FK FOREIGN KEY (ID_DUPLICATE_CHECK) REFERENCES DUPLICATE_CHECK(ID_DUPLICATE_CHECK)
);

CREATE INDEX IX_DCF_ID_DUPLICATE_CHECK ON DUPLICATE_CHECK_FIELD (ID_DUPLICATE_CHECK);

CREATE SEQUENCE DUPLICATE_CHECK_FIELD_SEQ MINVALUE 1 INCREMENT BY 1 START WITH 1 NOCACHE NOORDER  NOCYCLE;

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1771, SYSDATE, '5.5', 1691, 'Duplicate check')
;
